"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.aggregateFunctionCallPart = void 0;
const expressionPart_1 = require("./expressionPart");
const Utility_1 = require("typescript-dotnet-commonjs/System/Text/Utility");
class aggregateFunctionCallPart extends expressionPart_1.expressionPart {
    get Function() {
        return this._function;
    }
    set Function(value) {
        this._function = value;
    }
    get simpleName() {
        return this.Function.FunctionName;
    }
    resolve(expressionData, resolved, running, evaluateAllContexts = true, setValue = undefined) {
        resolved.resolved = true;
        if ((this.parameters.count > 0)) {
            let current = this.parameters.get(0).resolve(expressionData, resolved, running);
            let runningValue = running != null && running.Data != null && running.Data.containsKey(this) ? running.Data.getValue(this) : undefined;
            let result = this.Function.invoke(expressionData, current, runningValue, this.parameters, resolved);
            if (running != null && running.Data != null) {
                let d = { key: this, value: result };
                if (!running.Data.containsKey(this)) {
                    running.Data.add(d);
                }
            }
            return result;
        }
        else {
            return undefined;
        }
    }
    toString() {
        return Utility_1.format("{0}({1})", this.Function.FunctionName, this.parameters.toArray().join(", "));
    }
}
exports.aggregateFunctionCallPart = aggregateFunctionCallPart;
//# sourceMappingURL=aggregateFunctionCallPart.js.map