"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bracketPart = void 0;
const Utility_1 = require("typescript-dotnet-commonjs/System/Text/Utility");
const compoundPart_1 = require("./compoundPart");
const malformedExpressionException_1 = require("../../error/malformedExpressionException");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
class bracketPart extends compoundPart_1.compoundPart {
    constructor() {
        super(...arguments);
        this._bracketEnded = false;
    }
    get subParts() {
        return (new List_1.default()).add(this._expression);
    }
    get simpleName() {
        return "Item";
    }
    get BracketEnded() {
        return this._bracketEnded;
    }
    set BracketEnded(value) {
        this._bracketEnded = value;
    }
    get Expression() {
        return this._expression;
    }
    set Expression(value) {
        this._expression = value;
    }
    canAcceptMore() {
        return !this.BracketEnded;
    }
    addSubPart(part) {
        if (!this.BracketEnded) {
            this.Expression = part;
        }
        else {
            throw new malformedExpressionException_1.malformedExpressionException();
        }
        return true;
    }
    toString() {
        return Utility_1.format("({0})", this.Expression);
    }
    resolve(expressionData, /* out */ resolved, running, evaluateAllContexts = true, setValue = undefined) {
        return this.Expression.resolve(expressionData, /* out */ resolved, running, evaluateAllContexts, setValue);
    }
}
exports.bracketPart = bracketPart;
//# sourceMappingURL=bracketPart.js.map