"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.functionCallPart = void 0;
const expressionPart_1 = require("./expressionPart");
const Utility_1 = require("typescript-dotnet-commonjs/System/Text/Utility");
class functionCallPart extends expressionPart_1.expressionPart {
    constructor() {
        super();
    }
    get subParts() {
        return this.parameters;
    }
    get simpleName() {
        return this.function.functionName;
    }
    resolve(expressionData, /* out */ resolved, running, evaluateAllContexts = true, setValue = undefined) {
        if ((this.function != null)) {
            return this.function.invoke(expressionData, this.parameters, /* out */ resolved, running);
        }
        resolved.resolved = false;
        return undefined;
    }
    toString() {
        return Utility_1.format("{0}({1})", this.function.functionName, this.parameters.toArray().join(", "));
    }
}
exports.functionCallPart = functionCallPart;
//# sourceMappingURL=functionCallPart.js.map