"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.operationPart = void 0;
const compoundPart_1 = require("./compoundPart");
const Utility_1 = require("typescript-dotnet-commonjs/System/Text/Utility");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
class operationPart extends compoundPart_1.compoundPart {
    get subParts() {
        return (new List_1.default()).add(this.parameter1).add(this.parameter2);
    }
    get simpleName() {
        return this.parameter2 != null ? this.parameter2.simpleName : this.parameter1.simpleName;
    }
    resolve(expressionData, /* out */ resolved, running, evaluateAllContexts = true, setValue = null) {
        var _a, _b;
        if ((this.operator != null)) {
            let val1 = (_a = this.parameter1) === null || _a === void 0 ? void 0 : _a.resolve(expressionData, /* out */ resolved, /* running:*/ running, /* evaluateAllContexts:*/ evaluateAllContexts);
            let val2 = (_b = this.parameter2) === null || _b === void 0 ? void 0 : _b.resolve(expressionData, /* out */ resolved, /* running:*/ running, /* evaluateAllContexts:*/ evaluateAllContexts);
            resolved.resolved = true;
            return this.operator.invoke([val1, val2]);
        }
        resolved.resolved = false;
        return undefined;
    }
    addSubPart(part) {
        if ((this.parameter2 == null)) {
            this.parameter2 = part;
            return true;
        }
        return false;
    }
    canAcceptMore() {
        return (this.parameter2 == null);
    }
    toString() {
        var _a;
        return Utility_1.format("{0} {1} {2}", this.parameter1, (_a = this.operator) === null || _a === void 0 ? void 0 : _a.name, this.parameter2);
    }
}
exports.operationPart = operationPart;
//# sourceMappingURL=operationPart.js.map