"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.partList = void 0;
const compoundPart_1 = require("./compoundPart");
const stack_1 = require("../../utils/stack");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const outputVariables_1 = require("../../utils/outputVariables");
class partList extends compoundPart_1.compoundPart {
    constructor() {
        super(...arguments);
        this.lastResolvedLevel = 0;
        this.parts = new List_1.default();
    }
    get Parts() {
        return this.parts;
    }
    get simpleName() {
        return this.parts != null && this.parts.count > 0 ? this.parts.linq.last().simpleName : "Item";
    }
    addSubPart(part) {
        this.parts.add(part);
        return true;
    }
    resolve(expressionData, /* out */ resolved, running, evaluateAllContexts = true, setValue = undefined) {
        var _a;
        let contexts;
        if (evaluateAllContexts) {
            contexts = new stack_1.Stack();
            let temp = expressionData.contexts.clone();
            while (!temp.isEmpty()) {
                contexts.push(temp.pop());
            }
        }
        else {
            contexts = new stack_1.Stack();
            contexts.push(expressionData.contexts.pop());
        }
        let parentData = (_a = expressionData.parent) !== null && _a !== void 0 ? _a : expressionData;
        ;
        let tempData = expressionData.toSubEx();
        if ((evaluateAllContexts
            && ((this.lastResolvedLevel > 0)
                && (this.lastResolvedLevel < contexts.count())))) {
        }
        while ((contexts.count() > 0)) {
            let currentContext = contexts.pop();
            let subResolved = new outputVariables_1.outputVariables();
            let i = 0;
            for (; (i < this.parts.count); i++) {
                let item = this.parts.get(i);
                let popAtEnd = false;
                if (tempData.contexts.peek() != currentContext) {
                    tempData.contexts.push(currentContext);
                    popAtEnd = true;
                }
                parentData.monitorIfRequired(item, currentContext);
                if (i == (this.parts.count - 1)) {
                    currentContext = item.resolve(tempData, /* out */ subResolved, running, false, setValue);
                    //  For observing observable collections
                    parentData.monitorIfRequired(undefined, currentContext);
                }
                else {
                    currentContext = item.resolve(tempData, /* out */ subResolved, running, false, undefined);
                    if ((currentContext == null)) {
                        subResolved.resolved = false;
                    }
                }
                if (popAtEnd && !tempData.contexts.isEmpty()) {
                    tempData.contexts.pop();
                }
                if (!subResolved.resolved) {
                    break;
                }
            }
            if (!subResolved.resolved && i > 0) {
                resolved.resolved = false;
                return undefined;
            }
            if (subResolved.resolved) {
                resolved.resolved = true;
                this.lastResolvedLevel = (contexts.count() + 1);
                // parentData.resultCache.setValue(cacheKey, currentContext);
                return currentContext;
            }
        }
        resolved.resolved = false;
        return undefined;
    }
    toString() {
        return this.parts.toArray().join(".");
    }
}
exports.partList = partList;
//# sourceMappingURL=partList.js.map