"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.switchCasePart = void 0;
const expressionPart_1 = require("./expressionPart");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
class switchCasePart extends expressionPart_1.expressionPart {
    get simpleName() {
        return "Switch";
    }
    get subParts() {
        let ep = new List_1.default();
        ep.add(this.expression);
        this.switchData.Cases.forEach(item => {
            ep.add(item.key);
        });
        this.switchData.Cases.forEach(item => {
            ep.add(item.value);
        });
        return ep;
    }
    resolve(expressionData, resolved, running, evaluateAllContexts = true, setValue) {
        let result = undefined;
        let value = this.expression == null ? expressionData.contexts.peek() : this.expression.resolve(expressionData, resolved, running);
        result = this.switchData.forValue(expressionData, value, resolved);
        return result;
    }
}
exports.switchCasePart = switchCasePart;
//# sourceMappingURL=switchCasePart.js.map