"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exists = exports.find = exports.findAll = exports.limit = void 0;
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const mfunction_1 = require("../mfunction");
const reflectionExtender_1 = require("../../utils/reflectionExtender");
const outputVariables_1 = require("../../utils/outputVariables");
class limit extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return 2;
    }
    invoke(expressionData, parameters, 
    /* out */ resolved, running) {
        let list = new List_1.List();
        let tempData = expressionData.toSubEx();
        let obj = expressionData.contexts.peek();
        let subResolved = new outputVariables_1.outputVariables();
        if (obj instanceof List_1.List) {
            let limitStart = 0;
            let limitCount = 0;
            if (parameters.count > 1) {
                limitStart = parameters
                    .get(0)
                    .resolve(expressionData, /* out */ subResolved);
                limitCount = parameters
                    .get(1)
                    .resolve(expressionData, /* out */ subResolved);
            }
            else if (parameters.count == 1) {
                limitStart = 0;
                limitCount = parameters
                    .get(0)
                    .resolve(expressionData, /* out */ subResolved);
            }
            resolved.resolved = true;
            let count = 0;
            let includeCount = 0;
            for (let item of obj.toArray()) {
                if (count >= limitStart) {
                    list.add(item);
                    includeCount++;
                    if (limitCount > 0 && includeCount >= limitCount) {
                        break;
                    }
                }
                count++;
            }
        }
        return list;
    }
}
exports.limit = limit;
class baseFind extends mfunction_1.mfunction {
    invoke(expressionData, parameters, resolved, running) {
        throw new Error("Method not implemented.");
    }
    static applyFilter(expressionData, parameters, firstMatch, 
    /* out */ resolved, running) {
        let result = new List_1.List();
        resolved.resolved = false;
        let tempData = expressionData.toSubEx();
        let obj = expressionData.contexts.peek();
        let filterExpression = parameters.get(0);
        if (obj instanceof List_1.List || obj instanceof Array) {
            let done = false;
            while (!done) {
                result.clear();
                //  Clear();
                try {
                    let forObj = [];
                    if (obj instanceof List_1.List) {
                        forObj = obj.toArray();
                    }
                    else
                        forObj = obj;
                    for (let item of forObj) {
                        tempData.contexts.push(item);
                        let subResolved = new outputVariables_1.outputVariables();
                        let bResult = filterExpression.resolveGeneric(tempData, 
                        /* out */ subResolved, reflectionExtender_1.getType(Boolean), running);
                        tempData.contexts.pop();
                        if (subResolved && bResult) {
                            if (firstMatch) {
                                resolved.resolved = true;
                                return item;
                            }
                            else {
                                result.add(item);
                            }
                        }
                    }
                    done = true;
                }
                catch /*( :InvalidOperationException)*/ (_a) { }
            }
        }
        //  If 'single' was true and the loop didnt return before reaching here, it means no items matched.
        if (firstMatch) {
            resolved.resolved = true;
            return undefined;
        }
        else {
            resolved.resolved = true;
            return result;
        }
    }
}
class findAll extends baseFind {
    invoke(expressionData, parameters, 
    /* out */ resolved, running) {
        return baseFind.applyFilter(expressionData, parameters, false, 
        /* out */ resolved, running);
    }
}
exports.findAll = findAll;
class find extends baseFind {
    invoke(expressionData, parameters, 
    /* out */ resolved, running) {
        return baseFind.applyFilter(expressionData, parameters, true, 
        /* out */ resolved, running);
    }
}
exports.find = find;
class exists extends baseFind {
    invoke(expressionData, parameters, 
    /* out */ resolved, running) {
        return (baseFind.applyFilter(expressionData, parameters, true, 
        /* out */ resolved, running) != null);
    }
}
exports.exists = exists;
//# sourceMappingURL=find.js.map