"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.math_Pi = exports.math_Exp = exports.math_Tanh = exports.math_Cosh = exports.math_Sinh = exports.math_Tan = exports.math_Cos = exports.math_Sin = exports.math_Atan = exports.math_Acos = exports.math_Asin = exports.math_Sqrt = exports.math_Abs = exports.math_Atan2 = exports.math_Log = exports.math_Pow = exports.math_Round = exports.math_Max = exports.math_Min = exports.mathFunctions = exports.math_Sum = void 0;
const mfunction_1 = require("./../mfunction");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const typeMapper_1 = require("./../../types/typeMapper");
const reflectionExtender_1 = require("../../utils/reflectionExtender");
class math_Sum extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return -1;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        resolved.resolved = true;
        let result = 0;
        for (const ex of parameters.toArray()) {
            let item = ex.resolveGeneric(expressionData, resolved, reflectionExtender_1.getType(Object), running);
            if (resolved.resolved) {
                if ((item instanceof List_1.List)) {
                    let e = (item);
                    let en = e.getEnumerator();
                    while (en.moveNext()) {
                        result = (result + typeMapper_1.typeMapper.toType1(en.current, reflectionExtender_1.getType(Number)));
                    }
                }
                else {
                    result = (result + ex.resolveGeneric(expressionData, /* out */ resolved, reflectionExtender_1.getType(Number), running));
                }
            }
        }
        resolved.resolved = true;
        return result;
    }
}
exports.math_Sum = math_Sum;
class mathFunctions {
}
exports.mathFunctions = mathFunctions;
class math_Min extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return -1;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        resolved.resolved = true;
        let min = undefined;
        for (let ex of parameters.toArray()) {
            let item = ex.resolveGeneric(expressionData, resolved, reflectionExtender_1.getType(Object), running);
            if (resolved.resolved) {
                if ((item instanceof List_1.List)) {
                    let e = (item);
                    let en = e.getEnumerator();
                    while (en.moveNext()) {
                        let r = typeMapper_1.typeMapper.toType(en.current);
                        if (min == undefined)
                            min = r;
                        if ((r <= min)) {
                            min = r;
                        }
                    }
                }
                else {
                    let r = ex.resolveGeneric(expressionData, resolved, reflectionExtender_1.getType(Number), running);
                    if (min == undefined)
                        min = r;
                    if ((r <= min)) {
                        min = r;
                    }
                }
            }
        }
        resolved.resolved = true;
        return min;
    }
}
exports.math_Min = math_Min;
class math_Max extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return -1;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        resolved.resolved = true;
        let max = 0;
        for (let ex of parameters.toArray()) {
            let item = ex.resolveGeneric(expressionData, /* out */ resolved, reflectionExtender_1.getType(Object), running);
            if (resolved) {
                if (item instanceof List_1.List) {
                    let e = (item);
                    let en = e.getEnumerator();
                    while (en.moveNext()) {
                        let r = typeMapper_1.typeMapper.toType(en.current);
                        if ((r >= max)) {
                            max = r;
                        }
                    }
                }
                else {
                    let r = ex.resolveGeneric(expressionData, /* out */ resolved, reflectionExtender_1.getType(Number), running);
                    if ((r >= max)) {
                        max = r;
                    }
                }
            }
        }
        resolved.resolved = true;
        return max;
    }
}
exports.math_Max = math_Max;
class binary extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return 2;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        resolved.resolved = true;
        let result;
        let p1;
        let p2;
        if ((parameters.count > 1)) {
            p2 = parameters.get(1).resolve(expressionData, /* out */ resolved, /* running:*/ running);
        }
        if (resolved) {
            p1 = parameters.get(0).resolve(expressionData, /* out */ resolved, /* running:*/ running);
        }
        if (resolved) {
            result = this.subInvoke(p1, p2);
        }
        resolved.resolved = true;
        return result;
    }
}
class unary extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return 1;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        resolved.resolved = true;
        let result;
        let p1;
        if (resolved) {
            p1 = parameters.get(0).resolve(expressionData, /* out */ resolved, /* running:*/ running);
        }
        if (resolved) {
            result = this.subInvoke(p1);
        }
        resolved.resolved = true;
        return result;
    }
}
class math_Round extends binary {
    subInvoke(param1, param2) {
        if (param2 == undefined || param2 == 0)
            return Math.round(param1);
        else {
            let pow = Math.pow(10, param2);
            return Math.round(param1 * pow) / pow;
        }
    }
}
exports.math_Round = math_Round;
class math_Pow extends binary {
    subInvoke(param1, param2) {
        return Math.pow(param1, param2);
    }
}
exports.math_Pow = math_Pow;
class math_Log extends binary {
    subInvoke(param1, param2) {
        if (param2 == 0)
            return Math.log(param1);
        else
            return Math.log(param1); //, param2);
    }
}
exports.math_Log = math_Log;
class math_Atan2 extends binary {
    subInvoke(param1, param2) {
        return Math.atan2(param1, param2);
    }
}
exports.math_Atan2 = math_Atan2;
class math_Abs extends unary {
    subInvoke(param1) {
        return Math.abs(param1);
    }
}
exports.math_Abs = math_Abs;
class math_Sqrt extends unary {
    subInvoke(param1) {
        return Math.sqrt(param1);
    }
}
exports.math_Sqrt = math_Sqrt;
class math_Asin extends unary {
    subInvoke(param1) {
        return Math.asin(param1);
    }
}
exports.math_Asin = math_Asin;
class math_Acos extends unary {
    subInvoke(param1) {
        return Math.acos(param1);
    }
}
exports.math_Acos = math_Acos;
class math_Atan extends unary {
    subInvoke(param1) {
        return Math.atan(param1);
    }
}
exports.math_Atan = math_Atan;
class math_Sin extends unary {
    subInvoke(param1) {
        return Math.sin(param1);
    }
}
exports.math_Sin = math_Sin;
class math_Cos extends unary {
    subInvoke(param1) {
        return Math.cos(param1);
    }
}
exports.math_Cos = math_Cos;
class math_Tan extends unary {
    subInvoke(param1) {
        return Math.tan(param1);
    }
}
exports.math_Tan = math_Tan;
class math_Sinh extends unary {
    subInvoke(param1) {
        return Math.sinh(param1);
    }
}
exports.math_Sinh = math_Sinh;
class math_Cosh extends unary {
    subInvoke(param1) {
        return Math.cosh(param1);
    }
}
exports.math_Cosh = math_Cosh;
class math_Tanh extends unary {
    subInvoke(param1) {
        return Math.tanh(param1);
    }
}
exports.math_Tanh = math_Tanh;
class math_Exp extends unary {
    subInvoke(param1) {
        return Math.exp(param1);
    }
}
exports.math_Exp = math_Exp;
class math_Pi extends unary {
    subInvoke(param1) {
        if (param1 == 0)
            return Math.PI;
        else {
            let pow = Math.pow(10, param1);
            return Math.round(Math.PI * pow) / pow;
        }
    }
}
exports.math_Pi = math_Pi;
//# sourceMappingURL=math.js.map