"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.select = void 0;
const mfunction_1 = require("./../mfunction");
const namedSelection_1 = require("./../namedSelection");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const operationPart_1 = require("./../../compiler/parts/operationPart");
const selection_1 = require("../selection");
const outputVariables_1 = require("../../utils/outputVariables");
class select extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return -1;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        let obj = expressionData.contexts.peek();
        let tempData = expressionData.toSubEx();
        resolved.resolved = true;
        let isNamedSelection = (this.namedSelection || parameters.any((t => { var _a; return t instanceof operationPart_1.operationPart && ((_a = (t).operator) === null || _a === void 0 ? void 0 : _a.name) == "@"; })));
        if ((obj instanceof List_1.List)) {
            let result = new List_1.List();
            let done = false;
            while (!done) {
                result.clear();
                //  Clear();
                try {
                    for (let item of (obj).toArray()) {
                        let values = new Array(parameters.count);
                        tempData.contexts.push(item);
                        for (let i = 0; (i < parameters.count); i++) {
                            let subResolved = new outputVariables_1.outputVariables();
                            let value = parameters.get(i).resolve(tempData, /* out */ subResolved, /* running:*/ undefined);
                            if (!subResolved.resolved) {
                                value = undefined;
                            }
                            // if ((isNamedSelection
                            //     && !(value instanceof KeyValuePair))) {
                            //     value = new KeyValuePair<string, Object>(parameters[i].SimpleName, value);
                            // }
                            values[i] = value;
                        }
                        if (isNamedSelection) {
                            result.add(new namedSelection_1.namedSelection(values));
                        }
                        else if ((values.length == 1)) {
                            result.add(values[0]);
                        }
                        else {
                            result.add(new selection_1.selection(values));
                        }
                        tempData.contexts.pop();
                    }
                    done = true;
                }
                catch (e) {
                    let d = e;
                }
            }
            return result;
        }
        else {
            return obj;
        }
    }
}
exports.select = select;
//# sourceMappingURL=select.js.map