"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.aswitch = void 0;
const mfunction_1 = require("./../mfunction");
const switchParameterPart_1 = require("./../../compiler/parts/switchParameterPart");
const utils_1 = require("./../../compiler/utils");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const expressionCompiler_1 = require("../../compiler/expressionCompiler");
class aswitch extends mfunction_1.mfunction {
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return -1;
    }
    compileParameters(paramList, flags) {
        let parameters = new List_1.List();
        let switParameter = new switchParameterPart_1.switchParameterPart();
        flags.switchCasePart = true;
        let compileOjbect = new expressionCompiler_1.compileFlags(flags);
        compileOjbect.switchCasePart = true;
        switParameter.switchData = utils_1.utils.buildSwitchCaseOverload(paramList, compileOjbect);
        //switParameter.switchData = true;
        parameters.add(switParameter);
        return parameters;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        if (parameters.get(0) instanceof switchParameterPart_1.switchParameterPart) {
            let part = parameters.get(0);
            return part.resolve(expressionData, /* out */ resolved, /* running:*/ running);
        }
        else {
            resolved.resolved = false;
            return undefined;
        }
    }
}
exports.aswitch = aswitch;
//# sourceMappingURL=switch.js.map