"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mfunction = void 0;
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const expressionCompiler_1 = require("../compiler/expressionCompiler");
const invalidParametersException_1 = require("../error/invalidParametersException");
class mfunction {
    get functionName() {
        return typeof this;
    }
    getFunctionName() {
        return this.functionName;
    }
    get minParameters() {
        return 1;
    }
    get maxParameters() {
        return 1;
    }
    compileParameters(paramList, flags) {
        if ((((this.minParameters > 0)
            && (paramList.count < this.minParameters))
            || ((this.maxParameters >= 0)
                && (paramList.count > this.maxParameters)))) {
            throw new invalidParametersException_1.invalidParametersException(this.functionName, this.minParameters, this.maxParameters);
        }
        let parameters = new List_1.List();
        for (let item of paramList.toArray()) {
            parameters.add(expressionCompiler_1.expressionCompiler.compile(item, undefined, undefined, flags));
        }
        return parameters;
    }
    resolveParameter(parameter, tType, data, resolved, evaluateAllContexts = true, running = undefined) {
        let result = parameter.resolveGeneric(data, /* out */ resolved, tType, running, /* evaluateAllContexts:*/ evaluateAllContexts);
        if ((data.parent != null)) {
            data.parent.monitorIfRequired(parameter, result);
        }
        else {
            data.monitorIfRequired(parameter, result);
        }
        return result;
    }
}
exports.mfunction = mfunction;
//# sourceMappingURL=mfunction.js.map