﻿import expressionData from '../../expressionData';
import { groupDataContext } from '../../functions/groupDataContext';
import List from 'typescript-dotnet-commonjs/System/Collections/List';
import { Type } from 'typescript';
import { outputVariables } from '../../utils/outputVariables';

export abstract class expressionPart {

    abstract get simpleName(): string;
    public constructor() {

    }

    public get subParts(): List<expressionPart> {
        return new List<expressionPart>();
    }
    abstract resolve(expressionData: expressionData, resolved: outputVariables, running?: groupDataContext, evaluateAllContexts?: boolean, setValue?: Object | undefined): Object | undefined;

    resolveClass(expressionData: expressionData, resolved: outputVariables, targetType: Type, running?: groupDataContext, evaluateAllContexts: boolean = true, setValue?: Object): Object | undefined {
        if (targetType != undefined) {
            let result: Object | undefined = this.resolve(expressionData, resolved, running, evaluateAllContexts, setValue);
            return result;
            //return typeMapper.toType(result as Object, targetType);
        }
        else {
            return this.resolve(expressionData, resolved, undefined, evaluateAllContexts, setValue);
        }
    }

    resolveGeneric<T>(expressionData: expressionData, resolved: outputVariables, tType: Type, running?: groupDataContext | undefined, evaluateAllContexts: boolean = true, setValue: Object | undefined = undefined): T {
        if (running == undefined) {
            let result: Object | undefined = this.resolveClass(expressionData, resolved, tType, running, evaluateAllContexts, setValue);

            return result as T;
        }
        else {
            return this.resolveGeneric<T>(expressionData, resolved, tType, undefined, evaluateAllContexts, setValue);
        }
    }

    // resolve(expressionData: expressionData, resolved: outputVariables, running: groupDataContext, evaluateAllContexts: boolean, setValue: Object, targetType: unknown): Object;

    // resolve(expressionData: expressionData, resolved: outputVariables, running?: groupDataContext, evaluateAllContexts: boolean = true, setValue: Object = null, targetType?: any): Object {
    //     let result: Object = this.resolve(expressionData, resolved, running, evaluateAllContexts, setValue, undefined);
    //     if(targetType != undefined)
    //         return typeMapper.toType(result);
    // }   
}