﻿import { compoundPart } from './compoundPart';
import { format } from "typescript-dotnet-commonjs/System/Text/Utility";
import { expressionPart } from './expressionPart';
import expressionData from '../../expressionData';
import { groupDataContext } from '../../functions/groupDataContext';
import IEnumerable from 'typescript-dotnet-commonjs/System/Collections/Enumeration/IEnumerable';
import List from 'typescript-dotnet-commonjs/System/Collections/List';
import { operator } from '../../operators/operator';
import { outputVariables } from '../../utils/outputVariables';

export class operationPart extends compoundPart {

    public get subParts(): List<expressionPart> {

        return (new List<expressionPart>()).add(this.parameter1 as expressionPart).add(this.parameter2 as expressionPart);

    }

    public get simpleName(): string {
        return this.parameter2 != null ? this.parameter2.simpleName : (this.parameter1 as expressionPart).simpleName;
    }

    operator : operator | undefined;

    parameter1: expressionPart | undefined;

    parameter2: expressionPart | undefined;

    resolve(expressionData: expressionData, /* out */resolved: outputVariables, running: groupDataContext, evaluateAllContexts: boolean = true, setValue: Object | null = null): Object | undefined {
        if ((this.operator != null)) {
            let val1: Object = this.parameter1?.resolve(expressionData, /* out */resolved, /* running:*/ running, /* evaluateAllContexts:*/ evaluateAllContexts) as Object;
            let val2: Object = this.parameter2?.resolve(expressionData, /* out */resolved, /* running:*/ running, /* evaluateAllContexts:*/ evaluateAllContexts) as Object;
            resolved.resolved = true;
            return this.operator.invoke([val1, val2]);
        }

        resolved.resolved = false;
        return undefined;
    }

    public /* override */ addSubPart(part: expressionPart): boolean {
        if ((this.parameter2 == null)) {
            this.parameter2 = part;
            return true;
        }

        return false;
    }

    public /* override */ canAcceptMore(): boolean {
        return (this.parameter2 == null);
    }

    public /* override */ toString(): string {
        return format("{0} {1} {2}", this.parameter1, this.operator?.name, this.parameter2);
    }
}
