﻿import { expressionPart } from "./expressionPart";
import { switchPartData } from "./switchPartData";
import expressionData from "../../expressionData";
import { groupDataContext } from "../../functions/groupDataContext";
import IEnumerable from "typescript-dotnet-commonjs/System/Collections/Enumeration/IEnumerable";
import List from "typescript-dotnet-commonjs/System/Collections/List";
import { outputVariables } from "../../utils/outputVariables";


export class switchCasePart extends expressionPart {

    public get simpleName(): string {
        return "Switch";
    }

    public get subParts(): List<expressionPart> {
        let ep: List<expressionPart> = new List<expressionPart>();
        ep.add(this.expression);

        this.switchData.Cases.forEach(item => {
            ep.add(item.key);
        });
        this.switchData.Cases.forEach(item => {
            ep.add(item.value);
        });

        return ep;
    }

    switchData!: switchPartData;
    expression!: expressionPart;

    resolve(expressionData: expressionData, resolved: outputVariables, running: groupDataContext, evaluateAllContexts: boolean = true, setValue: Object): Object | undefined {
        let result: Object | undefined = undefined;
        let value: Object | undefined = this.expression == null ? expressionData.contexts.peek() : this.expression.resolve(expressionData, resolved, running);

        result = this.switchData.forValue(expressionData, value as Object, resolved);
        return result;
    }
}
