﻿import { iTypeMapper } from './iTypeMapper';
import { List } from 'typescript-dotnet-commonjs/System/Collections/List'
import { Type } from 'typescript';
import { getType } from '../utils/reflectionExtender';
import { utils } from '../compiler/utils';
import DateTime from 'typescript-dotnet-commonjs/System/Time/DateTime';
import TimeSpan from 'typescript-dotnet-commonjs/System/Time/TimeSpan';
import { isFloatType } from "./../utils/general";
import { outputVariables } from '../utils/outputVariables';
import { DictionaryObject } from '../utils/dictionaryObject';

export class defaultTypeMapper implements iTypeMapper {

    public toTypeGeneric<T>(item: Object, tType: Type, success: outputVariables): T {
        let result = this.toType(item, tType, success) as T;

        if (success.resolved) {
            return result as T;
        }
        else {
            return this.nullToTypeGeneric<T>(tType) as T;   
        }

    }

    // public /* virtual */ toType(item: Object, targetType: Type): Object | undefined{
    //     let success: boolean = true;
    //     let result = this.toType(item, targetType);
    //     if (success) {
    //         return result;
    //     }
    //     else {
    //         return this.nullToType(targetType);
    //     }

    // }

    public toType(item: Object, targetType: Type, success: outputVariables): Object | undefined {
        //  If the targetType is not the same or the parent of the object type
        try {
            success.resolved = true;
            if (item != null && getType(item) != targetType && targetType instanceof Object) {
                if ((typeof targetType === 'string')) {
                    return item.toString();
                }
                else if (typeof targetType == 'number') {
                    if (utils.IsNumericType(item)) {
                        if (isFloatType(item as number)) {
                            return Number.parseFloat(item as string)
                        }
                        else {
                            return Number.parseInt(item as string)
                        }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToInt16(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToInt32(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToInt64(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToByte(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToUInt16(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToUInt32(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToUInt64(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToDouble(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToSingle(item);
                        // }
                        // if ((targetType == typeof (number))) {
                        //     return Convert.ToDecimal(item);
                        // }
                        // else {
                        //     return Convert.ChangeType(item, targetType);
                        // }

                    }
                    else if ((typeof item === 'string')) {
                        if (String.isNullOrEmpty((<string>(item)))) {
                            return this.nullToType(targetType);
                        }
                        // else if ((targetType == typeof (System.SByte))) {
                        //     let v: System.SByte;
                        //     if (System.SByte.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     TryParse((<string>(item)), /* out */v);
                        //     return v;
                        //     success = false;
                        //     return null;
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }

                        // }
                        // else if ((typeof targetType == 'number')) {
                        //     Number.parseInt
                        //     // let v: number;
                        //     // if (number.TryParse((<string>(item)), /* out */v)) {
                        //     //     return v;
                        //     // }
                        //     // else {
                        //     //     success = false;
                        //     //     return null;
                        //     // }

                        // }
                        // else {
                        //     //return convert.ChangeType(item, targetType);
                        // }

                    }

                }
                // else if ((targetType == typeof (Number))) {
                //     return Number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (System.SByte))) {
                //     return System.SByte.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return;
                // }

                else if (typeof targetType == "number" && !isFloatType(targetType))
                    return Number.parseInt(item.toString());
                // else if (targetType == typeof(sbyte))
                //     return sbyte.Parse(item.ToString());
                // else if (targetType == typeof(byte))
                //     return byte.Parse(item.ToString());
                // else if (targetType == typeof (long))
                //     return long.Parse(item.ToString());
                // else if (targetType == typeof (short))
                //     return short.Parse(item.ToString());
                // else if (targetType == typeof (uint))
                //     return uint.Parse(item.ToString());
                // else if (targetType == typeof (ulong))
                //     return ulong.Parse(item.ToString());
                // else if (targetType == typeof (ushort))
                //     return ushort.Parse(item.ToString());
                // else if (targetType == typeof (double))
                //     return double.Parse(item.ToString());
                else if (typeof targetType == "number" && isFloatType(targetType))
                    return Number.parseFloat(item.toString());
                else if (typeof targetType == "boolean")
                    return "True".equals(item.toString());
                // else if (targetType == typeof (decimal))
                //     return decimal.Parse(item.ToString());
                else if (targetType instanceof DateTime)
                    return Date.parse(item.toString());
                // else if (targetType instanceof (TimeSpan))
                //     return TimeSpan.parse(DateTime.Parse(item.ToString()).ToString("HH:mm:ss"));
                else if (typeof item == 'string') {
                    // Assuming that the input is a CSV string and it needs to be split into multiple values list / array / dictionary

                    // if (targetType == typeof (string[]))
                    //     return ToArray<string>(item.ToString());
                    // else if (targetType == typeof (byte[]))
                    //     return ToArray<byte>(item.ToString());
                    // else if (targetType == typeof (int[]))
                    //     return ToArray<int>(item.ToString());
                    // else if (targetType == typeof (float[]))
                    //     return ToArray<float>(item.ToString());
                    // else if (targetType == typeof (double[]))
                    //     return ToArray<double>(item.ToString());
                    // else if (targetType == typeof (long[]))
                    //     return ToArray<long>(item.ToString());
                    // else if (targetType == typeof (bool[]))
                    //     return ToArray<bool>(item.ToString());
                    // else if (targetType == typeof (decimal[]))
                    //     return ToArray<decimal>(item.ToString());
                    // else if (targetType == typeof (object[]))
                    //     return ToArray<object>(item.ToString());
                    // else if (targetType == typeof (List<string>))
                    //         return ToList<string>(item.ToString());
                    // else if (targetType == typeof (List<byte>))
                    //         return ToList<byte>(item.ToString());
                    // else if (targetType == typeof (List<int>))
                    //         return ToList<int>(item.ToString());
                    // else if (targetType == typeof (List<float>))
                    //         return ToList<float>(item.ToString());
                    // else if (targetType == typeof (List<double>))
                    //         return ToList<double>(item.ToString());
                    // else if (targetType == typeof (List<decimal>))
                    //         return ToList<decimal>(item.ToString());
                    // else if (targetType == typeof (List<long>))
                    //         return ToList<long>(item.ToString());
                    // else if (targetType == typeof (List<bool>))
                    //         return ToList<bool>(item.ToString());
                    // else if (targetType == typeof (List<object>))
                    //         return ToList<object>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, string>))
                    //         return ToDictionary<string>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, byte>))
                    //         return ToDictionary<byte>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, int>))
                    //         return ToDictionary<int>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, float>))
                    //         return ToDictionary<float>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, double>))
                    //         return ToDictionary<double>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, decimal>))
                    //         return ToDictionary<decimal>(item.ToString());
                    // // else if (targetType == typeof(Dictionary<string, long>))
                    // //     return this.toDictionary<long>(item.ToString());
                    // else if (targetType instanceof Dictionary < sstring,)
                    //     return this.toDictionary<boolean>(item.ToString(), getType(item));
                    // else if (targetType == typeof (Dictionary<string, object>))
                    //         return ToDictionary<object>(item.ToString());
                }
            }
            else if (item == null)
                return this.nullToType(targetType);

            return item;
        }
        catch (Exception) {
            success.resolved = false;

            return this.nullToType(targetType);
        }

    }

    public nullToTypeGeneric<T>(tType: Type): T {
        return (<T>(this.nullToType(tType)));
    }

    public nullToType(targetType: Type): any  {
        if ((typeof targetType == 'number')) {
            return 0;
        }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        // if ((targetType == typeof (number))) {
        //     return;
        // }

        if ((typeof targetType == 'boolean')) {
            return false;
        }

        if ((targetType instanceof (DateTime))) {
            return new DateTime();
        }

        if ((targetType instanceof (TimeSpan))) {
            return new TimeSpan(0);
        }

        return null;
    }

    public /* virtual */ toArray<T>(str: string, tType: Type): T[] | undefined {
        if (!(String.isNullOrEmpty(str) || String.isNullOrWhiteSpace(str))) {
            let items: List<T> = new List<T>();
            let tokens: string[] = this.splitValues(str);
            for (let token in tokens) {
                items.add((<T>(this.toType(token, tType, new outputVariables()))));
            }

            return items.toArray();
        }

        return undefined;
    }

    public /* virtual */ toList<T>(str: string, tType: Type): List<T> | undefined {
        if (!(String.isNullOrEmpty(str) || String.isNullOrWhiteSpace(str))) {
            let items: List<T> = new List<T>();
            let tokens: string[] = this.splitValues(str);
            for (const token of tokens) {
                items.add((<T>(this.toType(token.trim(), tType, new outputVariables()))));
            }

            return items;
        }

        return undefined;
    }

    public toDictionary<T>(str: string, tType: Type): DictionaryObject {
        let outV = new outputVariables();
        if (!(String.isNullOrEmpty(str) || String.isNullOrWhiteSpace(str))) {
            let items: DictionaryObject = new DictionaryObject();
            let tokens: string[] = this.splitValues(str);
            for (const token of tokens) {
                let subTokens: string[] = token.split('=');
                items.add(subTokens[0], (this.toTypeGeneric(subTokens[1], tType, outV) as T) );
            }

            return items;
        }

        return new DictionaryObject();
    }

    private splitValues(str: string): string[] {
        //return str.split(',', '\r', '\n', ';');
        return str.split(/,|\r|\n|;/);
    }
}