import { DateTime } from 'typescript-dotnet-commonjs/System/Time/DateTime';

const legacyBuiltInProperty = {
    ["length"]: undefined,
    ["count"]: undefined,
    ["ticks"]: function (value: any) { return value; },
    ["date"]: function (value: any) { return Date.parse(new Date(value).toDateString()); },
    ["timeofday"]: function (value: any) { return (new DateTime(value)).timeOfDay; },
    ["year"]: function (value: any) { return (new DateTime(value)).year; },
    ["month"]: function (value: any) { return (new DateTime(value)).month; },
    ["minute"]: function (value: any) { return (new DateTime(value)).timeOfDay.minute; },
    ["day"]: function (value: any) { return (new DateTime(value)).toTimeStamp().day; },
    ["second"]: function (value: any) { return (new DateTime(value)).timeOfDay.second; },
    ["hour"]: function (value: any) { return (new DateTime(value)).timeOfDay.hour; },
    ["totaldays"]: function (value: any) { return (new DateTime(value)).timeOfDay.total.days; },
    ["totalhours"]: function (value: any) { return (new DateTime(value)).timeOfDay.total.hours; },
    ["totalminutes"]: function (value: any) { return (new DateTime(value)).timeOfDay.total.minutes; },
    ["totalseconds"]: function (value: any) { return (new DateTime(value)).timeOfDay.total.seconds; },
}

export default legacyBuiltInProperty;