export class Stack<TData> {
    constructor () { // THIS NEEDS TO COPIED 
        this._store = []; 
    }
    public _store: TData[] = [];
    public contains(currentContext: Object): boolean {
        return this._store.includes(currentContext as TData);
    }

    public count(): number {
        return this._store.length;
    }

    public isEmpty(): boolean {
        return this._store.length === 0;
    }

    public clear() {
        this._store = [];
    }

    public peek(): TData {
        let d = this.clone();
        return d.pop() as TData;
    }

    push(val: TData) {
        this._store.push(val);
    }

    pop(): TData {
        return this._store.pop() as TData;
    }

    clone(): Stack<TData>
    {
        let copiedStack = new Stack<TData>();
        this._store.forEach((element)=>{
            copiedStack.push(element);
        });
        return copiedStack;
    }
}

class Node<T> {

    public previous: Node<T>;
    public data: T;

    constructor(data: T, previous: Node<T>) {
        this.previous = previous;
        this.data = data;
    }

}
export const deepCopy = <T extends object>(target: T): T => {
    if (target === null) {
      return target;
    }
    if (target instanceof Date) {
      return new Date(target.getTime()) as any;
    }
    if (target instanceof Array) {
      const cp = [] as any[];
      (target as any[]).forEach((v) => { cp.push(v); });
      return cp.map((n: any) => deepCopy<any>(n)) as any;
    }
    if (typeof target === 'object' && target !== {}) {
      const cp = { ...(target as { [key: string]: any }) } as { [key: string]: any };
      Object.keys(cp).forEach(k => {
        cp[k] = deepCopy<any>(cp[k]);
      });
      return cp as T;
    }
    return target;
  };