import { testContext, Control, getContext } from "../testContext";
import { expressionEngine } from "../../src/expressionEngine";
import { expect } from "chai";
import { getType } from "../../src/utils/reflectionExtender";

describe('  Expression engine - To Number', () => {
    it('Case 1 - pass case - float', () => {
        let result: number = expressionEngine.evalGeneric<number>(undefined, "ToNumber(\"5.12\")");
        expect(5.12).to.equal(result);
    });

    it('Case 2 - pass case - integer', () => {
        let result: number = expressionEngine.evalGeneric<number>(undefined, "ToNumber(\"5000\")");
        expect(5000).to.equal(result);
    });

    it('Case 3 - pass case - with Bool function', () => {
        let contexts = getContext();
        let result: boolean = expressionEngine.evalGeneric<boolean>(contexts, "Bool(ToNumber(Controls[NonNegativeNumbers].Text) > ToNumber(0) | ToNumber(Controls[nndm_textbox].Text) > ToNumber(0))", undefined, undefined, true);
        expect(true).to.equal(result);
    });

    it('Case 4 - pass case 2 - with Bool function', () => {
        let contexts = getContext();
        let result: boolean = expressionEngine.evalGeneric<boolean>(contexts, "Bool(ToNumber(Controls[nndm_textbox].Text) > ToNumber(0))", undefined, undefined, true);
        expect(true).to.equal(result);
    });
});


